Crypto++ 8.1 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
ASN1Object Class Referenceabstract

Interface for encoding and decoding ASN1 objects. More...

Inheritance diagram for ASN1Object:

## Public Member Functions
virtual void | BERDecode (BufferedTransformation &bt)=0
| Decode this object from a BufferedTransformation. More...
virtual void | DEREncode (BufferedTransformation &bt) const =0
| Encode this object into a BufferedTransformation. More...
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...

## Detailed Description

Interface for encoding and decoding ASN1 objects.

Each class that derives from ASN1Object should provide a serialization format that controls subobject layout. Most of the time the serialization format is taken from a standard, like P1363 or an RFC.

Definition at line 3168 of file cryptlib.h.

## Member Function Documentation

## ◆ BERDecode()

virtual void ASN1Object::BERDecode | ( | BufferedTransformation & | bt | ) |
| pure virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Implemented in ed25519PublicKey, PKCS8PrivateKey, ed25519PrivateKey, X509PublicKey, Integer, x25519, InvertibleRSAFunction, InvertibleESIGNFunction, DL_GroupParameters_IntegerBased, and ESIGNFunction.

## ◆ DEREncode()

virtual void ASN1Object::DEREncode | ( | BufferedTransformation & | bt | ) | const
| pure virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Implemented in ed25519PublicKey, PKCS8PrivateKey, ed25519PrivateKey, X509PublicKey, Integer, x25519, InvertibleRSAFunction, InvertibleESIGNFunction, DL_GroupParameters_IntegerBased, and ESIGNFunction.

## ◆ BEREncode()

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const
| inline virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER).

This may be useful if DEREncode() would be too inefficient.

Definition at line 3187 of file cryptlib.h.

The documentation for this class was generated from the following file:

- cryptlib.h